﻿//using Syncfusion.GridHelperClasses;
using Syncfusion.Windows.Forms.Grid;
using Syncfusion.Windows.Forms.Grid.Grouping;
using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;


namespace DataGrid
{
    public partial class Form1 : Form
    {
        DataTable table;
        
        public Form1()
        {
            InitializeComponent();
            table = new DataTable();
            table = GetTable();
            this.gridGroupingControl1.DataSource = table.DefaultView;

            BindingContext bc = new BindingContext();
            this.gridGroupingControl1.BindingContext = bc;
            this.textBox1.BindingContext = bc;
            this.BindingContext = bc;

            this.gridGroupingControl1.ShowGroupDropArea = true;
            this.gridGroupingControl1.AllowProportionalColumnSizing = true;
            this.gridGroupingControl1.TableOptions.ListBoxSelectionMode = SelectionMode.MultiExtended;
            this.gridGroupingControl1.SourceListListChanged += gridGroupingControl1_SourceListListChanged;
            this.textBox1.KeyDown += textBox1_KeyDown;
        }

        //To update the grid without change selection
        void textBox1_KeyDown(object sender, KeyEventArgs e)
        {
            if (e.KeyCode == Keys.Enter)
            {
                this.gridGroupingControl1.Table.CurrentRecord.SetValue("Col1", this.textBox1.Text);
                this.gridGroupingControl1.Refresh();
            }
        }

        //To update the WinformControls while changing the current cell value
        void gridGroupingControl1_SourceListListChanged(object sender, Syncfusion.Grouping.TableListChangedEventArgs e)
        {
            if (e.ListChangedType == ListChangedType.ItemChanged)
            {
                e.Table.TableDirty = true;
            }
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            // Bind the textbox
            this.textBox1.DataBindings.Add("Text", this.table.DefaultView, "Col1");

            this.gridGroupingControl1.Table.Records[0].SetCurrent();
        }
        private DataTable GetTable()
        {
            DataTable dt = new DataTable("MyTable");

            int nCols = 10;
            int nRows = 50;

            for (int i = 0; i < nCols; i++)
                dt.Columns.Add(new DataColumn(string.Format("Col{0}", i)));

            for (int i = 0; i < nRows; ++i)
            {
                DataRow dr = dt.NewRow();
                for (int j = 0; j < nCols; j++)
                    //dr[j] = string.Format("row{0} col{1}", i, j);
                    dr[j] = string.Format("row{0}", i);
                dt.Rows.Add(dr);
            }
            return dt;
        }
    }

}
